//////////////////////////////////////////////////////////////////////
// Pocket PC Game Programming
// Chapter 9: Sprites and Animation
//
// CSprite Header File
//
// This file includes the CSprite class definition.
//
//////////////////////////////////////////////////////////////////////

#pragma once

#include "stdafx.h"
#include "CBitmap.h"

class CSprite : public CBitmap
{
private:
    int X_Loc, Y_Loc;
    int X_Dir, Y_Dir;
    int X_Spd, Y_Spd;

    HBITMAP hUnder;
    HDC hdcUnder;
    BOOL bUnderSaved;
    BOOL bAlive;
    LPRECT DestRect;
    RECT *Rect1;
    RECT *Rect2;

    void Init();

public:
    CSprite();
    CSprite(HDC hdc);
    virtual ~CSprite();
    BOOL SaveUnder(HDC hdc);
    BOOL RestoreUnder(HDC hdc);
    virtual BOOL TransBlit(COLORREF clrTrans);
    virtual BOOL BitBlit();
    virtual BOOL BitBlit(HDC hdc);
    virtual BOOL StretchBlit(int dx, int dy);
    virtual int ImageWidth() { return CBitmap::ImageWidth(); };
    virtual int ImageHeight() { return CBitmap::ImageHeight(); };
    virtual BOOL Intersected(CSprite *Sprite, POINT &pt);
    virtual BOOL Intersected(CSprite *Sprite, RECT &rt);
    
    BOOL IsAlive() { return bAlive; };
    void SetAlive(BOOL bNew) { bAlive = bNew; };
    int GetX() { return X_Loc; };
    void SetX(int vNew) { X_Loc = vNew; };
    void IncX(int vNew) { X_Loc += vNew; };
    int GetY() { return Y_Loc; };
    void SetY(int vNew) { Y_Loc = vNew; };
    void IncY(int vNew) { Y_Loc += vNew; };
    int GetXDir() { return X_Dir; };
    void SetXDir(int vNew) { X_Dir = vNew; };
    int GetYDir() { return Y_Dir; };
    void SetYDir(int vNew) { Y_Dir = vNew; };
    int GetXSpeed() { return X_Spd; };
    void SetXSpeed(int vNew) { X_Spd = vNew; };
    int GetYSpeed() { return Y_Spd; };
    void SetYSpeed(int vNew) { Y_Spd = vNew; };

};



